'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/switch.html
 */
var _switch = {
  PROPS: [{
    name: 'checked',
    get: function get(domNode) {
      return !!domNode.getAttribute('checked');
    }
  }, {
    name: 'disabled',
    get: function get(domNode) {
      return !!domNode.getAttribute('disabled');
    }
  }, {
    name: 'type',
    get: function get(domNode) {
      return domNode.getAttribute('type') || 'switch';
    }
  }, {
    name: 'color',
    get: function get(domNode) {
      return domNode.getAttribute('color') || '#04BE02';
    }
  }],
  handles: {
    onSwitchChange: function onSwitchChange(evt) {
      if (!this.domNode) return;
      this.domNode.setAttribute('checked', evt.detail.value);
      this.callSimpleEvent('change', evt);
    }
  }
};

exports.default = _switch;
