'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/camera.html
 */
var camera = {
  PROPS: [{
    name: 'mode',
    get: function get(domNode) {
      return domNode.getAttribute('mode') || 'normal';
    }
  }, {
    name: 'devicePosition',
    get: function get(domNode) {
      return domNode.getAttribute('device-position') || 'back';
    }
  }, {
    name: 'flash',
    get: function get(domNode) {
      return domNode.getAttribute('flash') || 'auto';
    }
  }, {
    name: 'frameSize',
    get: function get(domNode) {
      return domNode.getAttribute('frame-size') || 'medium';
    }
  }],
  handles: {
    onCameraStop: function onCameraStop(evt) {
      this.callSimpleEvent('stop', evt);
    },
    onCameraError: function onCameraError(evt) {
      this.callSimpleEvent('error', evt);
    },
    onCameraInitDone: function onCameraInitDone(evt) {
      this.callSimpleEvent('initdone', evt);
    },
    onCameraScanCode: function onCameraScanCode(evt) {
      this.callSimpleEvent('scancode', evt);
    }
  }
};

exports.default = camera;
