'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/form.html
 *
 * 可以认为下述 form 组件的属性和事件是没有用的，因为 button 组件会被封装到自定义组件内
 */
var form = {
  PROPS: [{
    name: 'reportSubmit',
    get: function get(domNode) {
      return !!domNode.getAttribute('report-submit');
    }
  }, {
    name: 'reportSubmitTimeout',
    get: function get(domNode) {
      return +domNode.getAttribute('report-submit-timeout') || 0;
    }
  }],
  handles: {
    onFormSubmit: function onFormSubmit(evt) {
      this.callSimpleEvent('submit', evt);
    },
    onFormReset: function onFormReset(evt) {
      this.callSimpleEvent('reset', evt);
    }
  }
};

exports.default = form;
