'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var mp = _interopDefault(require('miniapp-render'));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var componentMap = {
  // 视图容器
  'cover-image': {
    componentName: 'cover-image',
    config: new Promise(function (resolve) { resolve(require('./cover-image-123dfcae.js')); })
  },
  'cover-view': {
    componentName: 'cover-view',
    config: new Promise(function (resolve) { resolve(require('./cover-view-b48eec32.js')); })
  },
  'movable-area': {
    componentName: 'movable-area',
    config: new Promise(function (resolve) { resolve(require('./movable-area-ca8604c0.js')); })
  },
  'scroll-view': {
    componentName: 'scroll-view',
    config: new Promise(function (resolve) { resolve(require('./scroll-view-8ed6bd57.js')); })
  },
  swiper: {
    componentName: 'swiper',
    config: new Promise(function (resolve) { resolve(require('./swiper-6cd78206.js')); })
  },
  view: {
    componentName: 'view',
    config: new Promise(function (resolve) { resolve(require('./view-d3727cda.js')); })
  },
  // 基础内容
  icon: {
    componentName: 'icon',
    config: new Promise(function (resolve) { resolve(require('./icon-d587d0e6.js')); })
  },
  progress: {
    componentName: 'progress',
    config: new Promise(function (resolve) { resolve(require('./progress-9beea17c.js')); })
  },
  text: {
    componentName: 'text',
    config: new Promise(function (resolve) { resolve(require('./text-661f0634.js')); })
  },
  // 表单组件
  button: {
    componentName: 'button',
    config: new Promise(function (resolve) { resolve(require('./button-28bb028f.js')); })
  },
  editor: {
    componentName: 'editor',
    config: new Promise(function (resolve) { resolve(require('./editor-b5c284f9.js')); })
  },
  form: {
    componentName: 'form',
    config: new Promise(function (resolve) { resolve(require('./form-e860e22e.js')); })
  },
  INPUT: {
    componentName: 'input',
    config: new Promise(function (resolve) { resolve(require('./input-a5969954.js')); })
  },
  picker: {
    componentName: 'picker',
    config: new Promise(function (resolve) { resolve(require('./picker-dad18e7b.js')); })
  },
  'picker-view': {
    componentName: 'picker-view',
    config: new Promise(function (resolve) { resolve(require('./picker-view-93c594e8.js')); })
  },
  slider: {
    componentName: 'slider',
    config: new Promise(function (resolve) { resolve(require('./slider-1f7c7b7e.js')); })
  },
  switch: {
    componentName: 'switch',
    config: new Promise(function (resolve) { resolve(require('./switch-2bc5c0d4.js')); })
  },
  TEXTAREA: {
    componentName: 'textarea',
    config: new Promise(function (resolve) { resolve(require('./textarea-94bf4eb2.js')); })
  },
  // 导航
  navigator: {
    componentName: 'navigator',
    config: new Promise(function (resolve) { resolve(require('./navigator-1c54ec3e.js')); })
  },
  // 媒体组件
  camera: {
    componentName: 'camera',
    config: new Promise(function (resolve) { resolve(require('./camera-2797f692.js')); })
  },
  image: {
    componentName: 'image',
    config: new Promise(function (resolve) { resolve(require('./image-fa2f107a.js')); })
  },
  'live-player': {
    componentName: 'live-player',
    config: new Promise(function (resolve) { resolve(require('./live-player-1b32df82.js')); })
  },
  'live-pusher': {
    componentName: 'live-pusher',
    config: new Promise(function (resolve) { resolve(require('./live-pusher-0aaee569.js')); })
  },
  VIDEO: {
    componentName: 'video',
    config: new Promise(function (resolve) { resolve(require('./video-c92e1d9f.js')); })
  },
  // 地图
  map: {
    componentName: 'map',
    config: new Promise(function (resolve) { resolve(require('./map-9627d9f7.js')); })
  },
  // 画布
  CANVAS: {
    componentName: 'canvas',
    config: new Promise(function (resolve) { resolve(require('./canvas-6da0cb1a.js')); })
  },
  // 开放能力
  ad: {
    componentName: 'ad',
    config: new Promise(function (resolve) { resolve(require('./ad-602e0f1c.js')); })
  },
  'official-account': {
    componentName: 'official-account',
    config: new Promise(function (resolve) { resolve(require('./official-account-ddd21bb1.js')); })
  },
  'open-data': {
    componentName: 'open-data',
    config: new Promise(function (resolve) { resolve(require('./open-data-70297b49.js')); })
  },
  'web-view': {
    componentName: 'web-view',
    config: new Promise(function (resolve) { resolve(require('./web-view-1b8d2b66.js')); })
  }
};
var subComponentMap = {
  'movable-view': new Promise(function (resolve) { resolve(require('./movable-view-42b227c2.js')); }),
  'swiper-item': new Promise(function (resolve) { resolve(require('./swiper-item-696a3d90.js')); }),
  'picker-view-column': new Promise(function (resolve) { resolve(require('./picker-view-column-030a7d37.js')); })
};
var componentKeys = Object.keys(componentMap);
var componentNameMap = {};
var PROPS = {};
var handles = {};
componentKeys.forEach(function (key) {
  var _componentMap$key = componentMap[key],
      componentName = _componentMap$key.componentName,
      config = _componentMap$key.config;
  componentNameMap[key] = componentName;
  PROPS[componentName] = config.PROPS;
  Object.assign(handles, config.handles);
});
Object.keys(subComponentMap).forEach(function (key) {
  var config = subComponentMap[key];
  Object.assign(handles, config.handles);
});
var component = {
  componentNameMap: componentNameMap,
  PROPS: PROPS,
  handles: handles,
  subComponentMap: subComponentMap
};

var initData = component.PROPS;

var _mp$$$adapter = mp.$$adapter,
    cache = _mp$$$adapter.cache,
    tool = _mp$$$adapter.tool;
var subComponentMap$1 = component.subComponentMap;
var ELEMENT_DIFF_KEYS = ['nodeId', 'pageId', 'tagName', 'compName', 'id', 'class', 'style', 'src', 'mode', 'lazyLoad', 'showMenuByLongpress', 'isImage', 'isLeaf', 'isSimple', 'content', 'extra'];
var TEXT_NODE_DIFF_KEYS = ['nodeId', 'pageId', 'content'];
var NEET_SPLIT_CLASS_STYLE_FROM_CUSTOM_ELEMENT = ['INPUT', 'TEXTAREA', 'VIDEO', 'CANVAS', 'BUILTIN-COMPONENT', 'CUSTOM-COMPONENT']; // 需要分离 class 和 style 的节点

var NEET_BEHAVIOR_NORMAL_CUSTOM_ELEMENT = ['swiper-item', 'movable-view', 'picker-view-column'];
var NEET_RENDER_TO_CUSTOM_ELEMENT = ['IFRAME'].concat(NEET_SPLIT_CLASS_STYLE_FROM_CUSTOM_ELEMENT); // 必须渲染成自定义组件的节点

var NOT_SUPPORT = ['IFRAME'];
/**
 * 过滤子节点，只获取儿子节点
 */

function filterNodes(domNode, level) {
  var window = cache.getWindow(domNode.$$pageId);
  var childNodes = domNode.childNodes || [];
  if (!childNodes.map) return [];
  if (NOT_SUPPORT.indexOf(domNode.tagName) >= 0) return []; // 不支持标签，不渲染子节点

  return childNodes.map(function (child) {
    var domInfo = child.$$domInfo;
    if (domInfo.type !== 'element' && domInfo.type !== 'text') return;
    domInfo.class = "h5-" + domInfo.tagName + " node-" + domInfo.nodeId + " " + (domInfo.class || ''); // 增加默认 class

    domInfo.domNode = child; // 特殊节点

    if (NEET_SPLIT_CLASS_STYLE_FROM_CUSTOM_ELEMENT.indexOf(child.tagName) >= 0) {
      if (domInfo.tagName === 'builtin-component' && NEET_BEHAVIOR_NORMAL_CUSTOM_ELEMENT.indexOf(child.behavior) !== -1) {
        // 特殊内置组件，强制作为某内置组件的子组件，需要直接在当前模板渲染
        domInfo.compName = child.behavior;
        domInfo.extra = {
          hidden: child.getAttribute('hidden') || false
        }; // 补充该内置组件的属性

        var _ref = subComponentMap$1[child.behavior] || {},
            PROPS = _ref.PROPS;

        if (PROPS && PROPS.length) {
          PROPS.forEach(function (_ref2) {
            var name = _ref2.name,
                get = _ref2.get;
            domInfo.extra[name] = get(child);
          });
        }

        if (child.children.length && level > 0) {
          domInfo.childNodes = filterNodes(child, level - 1);
        }

        return domInfo;
      } // 不需要处理 id 和样式


      domInfo.class = "h5-" + domInfo.tagName + " " + (domInfo.tagName === 'builtin-component' ? 'builtin-' + child.behavior : '');
      domInfo.id = '';
      domInfo.style = '';
    } // 判断图片节点


    domInfo.isImage = domInfo.type === 'element' && domInfo.tagName === 'img';

    if (domInfo.isImage) {
      domInfo.src = child.src ? tool.completeURL(child.src, window.location.origin, true) : '';
      domInfo.mode = child.getAttribute('mode') || '';
      domInfo.lazyLoad = !!child.getAttribute('lazy-load');
      domInfo.showMenuByLongpress = !!child.getAttribute('show-menu-by-longpress');
    } else {
      domInfo.src = '';
      domInfo.mode = '';
      domInfo.lazyLoad = false;
      domInfo.showMenuByLongpress = false;
    } // 判断叶子节点


    domInfo.isLeaf = !domInfo.isImage && domInfo.type === 'element' && !child.children.length && NEET_RENDER_TO_CUSTOM_ELEMENT.indexOf(child.tagName.toUpperCase()) === -1;

    if (domInfo.isLeaf) {
      domInfo.content = child.childNodes.map(function (childNode) {
        return childNode.$$domInfo.type === 'text' ? childNode.textContent : '';
      }).join('');
    } // 判断可直接用 view 渲染的简单子节点


    domInfo.isSimple = !domInfo.isLeaf && domInfo.type === 'element' && NEET_RENDER_TO_CUSTOM_ELEMENT.indexOf(child.tagName.toUpperCase()) === -1 && level > 0;

    if (domInfo.isSimple) {
      domInfo.content = '';
      domInfo.childNodes = filterNodes(child, level - 1);
    }

    return domInfo;
  }).filter(function (child) {
    return !!child;
  });
}
/**
 * 比较新旧子节点是否不同
 */


function checkDiffChildNodes(newChildNodes, oldChildNodes) {
  if (newChildNodes.length !== oldChildNodes.length) return true;

  for (var i = 0, len = newChildNodes.length; i < len; i++) {
    var newChild = newChildNodes[i];
    var oldChild = oldChildNodes[i];
    if (newChild.type !== oldChild.type) return true;
    var keys = newChild.type === 'element' ? ELEMENT_DIFF_KEYS : TEXT_NODE_DIFF_KEYS;

    for (var _iterator = keys, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref3;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref3 = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref3 = _i.value;
      }

      var key = _ref3;
      var newValue = newChild[key];
      var oldValue = oldChild[key];

      if (typeof newValue === 'object') {
        // 值为对象，则判断对象顶层值是否有变化
        if (typeof oldValue !== 'object') return true;
        var objectKeys = Object.keys(newValue);

        for (var _i2 = 0, _objectKeys = objectKeys; _i2 < _objectKeys.length; _i2++) {
          var objectKey = _objectKeys[_i2];
          if (newValue[objectKey] !== oldValue[objectKey]) return true;
        }
      }

      if (newValue !== oldValue) return true;
    } // 比较孙子后辈节点


    var newGrandChildNodes = newChild.childNodes || [];
    var oldGrandChildNodes = oldChild.childNodes || [];

    if (newGrandChildNodes.length || oldGrandChildNodes.length) {
      var checkRes = checkDiffChildNodes(newGrandChildNodes, oldGrandChildNodes);
      if (checkRes) return true;
    }
  }

  return false;
}
/**
 * 检查组件属性
 */


function checkComponentAttr(name, domNode, destData, oldData) {
  var attrs = initData[name];
  destData.builtinComponentName = name;

  if (attrs && attrs.length) {
    for (var _iterator2 = attrs, _isArray2 = Array.isArray(_iterator2), _i3 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
      var _ref4;

      if (_isArray2) {
        if (_i3 >= _iterator2.length) break;
        _ref4 = _iterator2[_i3++];
      } else {
        _i3 = _iterator2.next();
        if (_i3.done) break;
        _ref4 = _i3.value;
      }

      var _ref5 = _ref4,
          _name = _ref5.name,
          get = _ref5.get;
      var newValue = get(domNode);
      if (!oldData || oldData[_name] !== newValue) destData[_name] = newValue;
    }
  } // 补充 id、class、style 和 hidden


  var newId = domNode.id;
  if (!oldData || oldData.id !== newId) destData.id = newId;
  var newClass = "builtin-component-" + name + " node-" + domNode.$$nodeId + " " + (domNode.className || '');
  if (!oldData || oldData.class !== newClass) destData.class = newClass;
  var newStyle = domNode.style.cssText;
  if (!oldData || oldData.style !== newStyle) destData.style = newStyle;
  var newHidden = domNode.getAttribute('hidden') || false;
  if (!oldData || oldData.hidden !== newHidden) destData.hidden = newHidden;
}
/**
 * 处理不需要渲染成自定义组件的节点
 */


function dealWithLeafAndSimple(childNodes, onChildNodesUpdate) {
  if (childNodes && childNodes.length) {
    childNodes = childNodes.map(function (originChildNode) {
      var childNode = Object.assign({}, originChildNode);

      if (childNode.isLeaf || childNode.isSimple) {
        childNode.domNode.$$clearEvent('$$childNodesUpdate');
        childNode.domNode.addEventListener('$$childNodesUpdate', onChildNodesUpdate);
      }

      delete childNode.domNode;
      childNode.childNodes = dealWithLeafAndSimple(childNode.childNodes, onChildNodesUpdate);
      return childNode;
    });
  }

  return childNodes;
}
/**
 * 检查事件是否经过某个节点
 */


function checkEventAccessDomNode(evt, domNode, dest) {
  dest = dest || domNode.ownerDocument.body;
  var target = evt.target; // 该节点就是目标节点

  if (domNode === dest) return true;

  while (target && target !== dest) {
    if (target === domNode) return true;
    target = target.parentNode;
  }

  return false;
}
/**
 * 查找最近的符合条件的祖先节点
 */


function findParentNode(domNode, tagName) {
  var checkParentNode = function checkParentNode(parentNode, tagName) {
    if (!parentNode) return false;
    if (parentNode.tagName === tagName) return true;
    if (parentNode.tagName === 'BUILTIN-COMPONENT' && parentNode.behavior === tagName.toLowerCase()) return true;
    return false;
  };

  var parentNode = domNode.parentNode;
  if (checkParentNode(parentNode, tagName)) return parentNode;

  while (parentNode && parentNode.tagName !== tagName) {
    parentNode = parentNode.parentNode;
    if (checkParentNode(parentNode, tagName)) return parentNode;
  }

  return null;
}

var _ = {
  NOT_SUPPORT: NOT_SUPPORT,
  filterNodes: filterNodes,
  checkDiffChildNodes: checkDiffChildNodes,
  checkComponentAttr: checkComponentAttr,
  dealWithLeafAndSimple: dealWithLeafAndSimple,
  checkEventAccessDomNode: checkEventAccessDomNode,
  findParentNode: findParentNode
};

var Event = mp.$$adapter.Event;
var NOT_SUPPORT$1 = _.NOT_SUPPORT;
var componentNameMap$1 = component.componentNameMap;
var initHandle = {
  /**
     * 初始化
     */
  init: function init(data) {
    var domNode = this.domNode;
    var tagName = domNode.tagName;

    if (tagName === 'BUILTIN-COMPONENT') {
      // 内置组件
      data.builtinComponentName = domNode.behavior;
      var builtinComponentName = componentNameMap$1[data.builtinComponentName];
      if (builtinComponentName) _.checkComponentAttr(builtinComponentName, domNode, data);else console.warn("value \"" + data.builtinComponentName + "\" is not supported for builtin-component's behavior");
    } else if (tagName === 'CUSTOM-COMPONENT') {
      // 自定义组件
      data.customComponentName = domNode.behavior;
      data.nodeId = this.nodeId;
      data.pageId = this.pageId;
    } else if (NOT_SUPPORT$1.indexOf(tagName) >= 0) {
      // 不支持标签
      data.builtinComponentName = 'not-support';
      data.content = domNode.textContent;
    } else {
      // 可替换 html 标签
      var _builtinComponentName = componentNameMap$1[tagName];
      if (_builtinComponentName) _.checkComponentAttr(_builtinComponentName, domNode, data);
    }
  },

  /**
     * 触发简单节点事件
     */
  callSimpleEvent: function callSimpleEvent(eventName, evt, domNode) {
    domNode = domNode || this.domNode;
    if (!domNode) return;
    domNode.$$trigger(eventName, {
      event: new Event({
        name: eventName,
        target: domNode,
        eventPhase: Event.AT_TARGET,
        detail: evt && evt.detail,
        $$extra: evt && evt.extra
      }),
      currentTarget: domNode
    });
  }
};

function getId(instance) {
  var nodeId = instance.dataset.privateNodeId;
  var pageId = instance.dataset.privatePageId;
  return {
    nodeId: nodeId,
    pageId: pageId
  };
}
var PROPS$1 = 'properties';
var MOUNT = 'attached';
var UNMOUNT = 'detached';
var INIT = 'created';

var _Component;
var _mp$$$adapter$1 = mp.$$adapter,
    cache$1 = _mp$$$adapter$1.cache,
    EventTarget = _mp$$$adapter$1.EventTarget,
    tool$1 = _mp$$$adapter$1.tool;
var NOT_SUPPORT$2 = _.NOT_SUPPORT;
var componentNameMap$2 = component.componentNameMap,
    handles$1 = component.handles; // dom 子树作为自定义组件渲染的层级数

var MAX_DOM_SUB_TREE_LEVEL = 10;
var DOM_SUB_TREE_LEVEL = 10;
Component((_Component = {}, _Component[PROPS$1] = {
  inCover: {
    type: Boolean,
    value: false
  }
}, _Component.data = {
  builtinComponentName: '',
  // 需要渲染的内置组件名
  customComponentName: '',
  // 需要渲染的自定义组件名
  innerChildNodes: [],
  // 内置组件的孩子节点
  childNodes: [] // 孩子节点

}, _Component.options = {
  addGlobalClass: true // 开启全局样式

}, _Component[INIT] = function () {
  var config = cache$1.getConfig(); // 根据配置重置全局变量

  var domSubTreeLevel = +config.optimization.domSubTreeLevel;
  if (domSubTreeLevel >= 1 && domSubTreeLevel <= MAX_DOM_SUB_TREE_LEVEL) DOM_SUB_TREE_LEVEL = domSubTreeLevel;
}, _Component[MOUNT] = function () {
  var _getId = getId(this),
      nodeId = _getId.nodeId,
      pageId = _getId.pageId;

  var data = {};
  this.nodeId = nodeId;
  this.pageId = pageId; // 记录 dom

  this.domNode = cache$1.getNode(pageId, nodeId);
  if (!this.domNode) return; // TODO，为了兼容基础库的一个 bug，暂且如此实现

  if (this.domNode.tagName === 'CANVAS') this.domNode._builtInComponent = this; // 存储 document

  this.document = cache$1.getDocument(pageId); // 监听全局事件

  this.onChildNodesUpdate = tool$1.throttle(this.onChildNodesUpdate.bind(this));
  this.domNode.$$clearEvent('$$childNodesUpdate');
  this.domNode.addEventListener('$$childNodesUpdate', this.onChildNodesUpdate);
  this.onSelfNodeUpdate = tool$1.throttle(this.onSelfNodeUpdate.bind(this));
  this.domNode.$$clearEvent('$$domNodeUpdate');
  this.domNode.addEventListener('$$domNodeUpdate', this.onSelfNodeUpdate); // 初始化

  this.init(data); // 初始化孩子节点

  var childNodes = _.filterNodes(this.domNode, DOM_SUB_TREE_LEVEL - 1);

  var dataChildNodes = _.dealWithLeafAndSimple(childNodes, this.onChildNodesUpdate);

  if (data.builtinComponentName || data.customComponentName) {
    // 内置组件/自定义组件
    data.innerChildNodes = dataChildNodes;
    data.childNodes = [];
  } else {
    // 普通标签
    data.innerChildNodes = [];
    data.childNodes = dataChildNodes;
  } // 执行一次 setData


  if (Object.keys(data).length) this.setData(data);
}, _Component[UNMOUNT] = function () {
  this.nodeId = null;
  this.pageId = null;
  this.domNode = null;
  this.document = null;
}, _Component.methods = _extends({
  /**
       * 监听子节点变化
       */
  onChildNodesUpdate: function onChildNodesUpdate() {
    // 判断是否已被销毁
    if (!this.pageId || !this.nodeId) return; // 儿子节点有变化

    var childNodes = _.filterNodes(this.domNode, DOM_SUB_TREE_LEVEL - 1);

    var oldChildNodes = this.data.builtinComponentName || this.data.customComponentName ? this.data.innerChildNodes : this.data.childNodes;

    if (_.checkDiffChildNodes(childNodes, oldChildNodes)) {
      var dataChildNodes = _.dealWithLeafAndSimple(childNodes, this.onChildNodesUpdate);

      var newData = {};

      if (this.data.builtinComponentName || this.data.customComponentName) {
        // 内置组件/自定义组件
        newData.innerChildNodes = dataChildNodes;
        newData.childNodes = [];
      } else {
        // 普通标签
        newData.innerChildNodes = [];
        newData.childNodes = dataChildNodes;
      }

      this.setData(newData);
    } // 触发子节点变化


    var childNodeStack = [].concat(childNodes);
    var childNode = childNodeStack.pop();

    while (childNode) {
      if (childNode.type === 'element' && !childNode.isLeaf && !childNode.isSimple) {
        childNode.domNode.$$trigger('$$childNodesUpdate');
      }

      if (childNode.childNodes && childNode.childNodes.length) childNode.childNodes.forEach(function (subChildNode) {
        return childNodeStack.push(subChildNode);
      });
      childNode = childNodeStack.pop();
    }
  },

  /**
       * 监听当前节点变化
       */
  onSelfNodeUpdate: function onSelfNodeUpdate() {
    // 判断是否已被销毁
    if (!this.pageId || !this.nodeId) return;
    var newData = {};
    var domNode = this.domNode;
    var data = this.data;
    var tagName = domNode.tagName;

    if (tagName === 'BUILTIN-COMPONENT') {
      // 内置组件
      if (data.builtinComponentName !== domNode.behavior) newData.builtinComponentName = domNode.behavior;
      var builtinComponentName = componentNameMap$2[domNode.behavior];
      if (builtinComponentName) _.checkComponentAttr(builtinComponentName, domNode, newData, data);
    } else if (tagName === 'CUSTOM-COMPONENT') {
      // 自定义组件
      if (data.customComponentName !== domNode.behavior) newData.customComponentName = domNode.behavior;
      if (data.nodeId !== this.nodeId) data.nodeId = this.nodeId;
      if (data.pageId !== this.pageId) data.pageId = this.pageId;
    } else if (NOT_SUPPORT$2.indexOf(tagName) >= 0) {
      // 不支持标签
      newData.builtinComponentName = 'not-support';
      if (data.content !== domNode.content) newData.content = domNode.textContent;
    } else {
      // 可替换 html 标签
      var _builtinComponentName = componentNameMap$2[tagName];
      if (_builtinComponentName) _.checkComponentAttr(_builtinComponentName, domNode, newData, data);
    }

    this.setData(newData);
  },

  /**
       * 触发事件
       */
  callEvent: function callEvent(eventName, evt, extra) {
    var _this = this;

    var pageId = this.pageId;
    var originNodeId = evt.currentTarget.dataset.privateNodeId || this.nodeId;
    var originNode = cache$1.getNode(pageId, originNodeId);
    if (!originNode) return;
    EventTarget.$$process(originNode, eventName, evt, extra, function (domNode, evt, isCapture) {
      // 延迟触发跳转，先等所有同步回调处理完成
      setTimeout(function () {
        if (evt.cancelable) return;
        var window = cache$1.getWindow(_this.pageId); // 处理特殊节点事件

        if (domNode.tagName === 'A' && evt.type === 'click' && !isCapture) {
          // 处理 a 标签的跳转
          var href = domNode.href;
          var target = domNode.target;
          if (!href || href.indexOf('javascript') !== -1) return;
          if (target === '_blank') window.open(href);else window.location.href = href;
        } else if (domNode.tagName === 'LABEL' && evt.type === 'click' && !isCapture) {
          // 处理 label 的点击
          var forValue = domNode.getAttribute('for');
          var targetDomNode;

          if (forValue) {
            targetDomNode = window.document.getElementById(forValue);
          } else {
            targetDomNode = domNode.querySelector('input'); // 寻找 switch 节点

            if (!targetDomNode) targetDomNode = domNode.querySelector('builtin-component[behavior=switch]');
          }

          if (!targetDomNode || !!targetDomNode.getAttribute('disabled')) return; // 找到了目标节点

          if (targetDomNode.tagName === 'INPUT') {
            if (_.checkEventAccessDomNode(evt, targetDomNode, domNode)) return;
            var type = targetDomNode.type;

            if (type === 'radio') {
              targetDomNode.checked = true;
              var name = targetDomNode.name;
              var otherDomNodes = window.document.querySelectorAll("input[name=" + name + "]") || [];

              for (var _iterator = otherDomNodes, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
                var _ref;

                if (_isArray) {
                  if (_i >= _iterator.length) break;
                  _ref = _iterator[_i++];
                } else {
                  _i = _iterator.next();
                  if (_i.done) break;
                  _ref = _i.value;
                }

                var otherDomNode = _ref;

                if (otherDomNode.type === 'radio' && otherDomNode !== targetDomNode) {
                  otherDomNode.checked = false;
                }
              }

              _this.callSimpleEvent('change', {
                detail: {
                  value: targetDomNode.value
                }
              }, targetDomNode);
            } else if (type === 'checkbox') {
              targetDomNode.checked = !targetDomNode.checked;

              _this.callSimpleEvent('change', {
                detail: {
                  value: targetDomNode.checked ? [targetDomNode.value] : []
                }
              }, targetDomNode);
            } else {
              targetDomNode.focus();
            }
          } else if (targetDomNode.tagName === 'BUILTIN-COMPONENT') {
            if (_.checkEventAccessDomNode(evt, targetDomNode, domNode)) return;
            var behavior = targetDomNode.behavior;

            if (behavior === 'switch') {
              var checked = !targetDomNode.getAttribute('checked');
              targetDomNode.setAttribute('checked', checked);

              _this.callSimpleEvent('change', {
                detail: {
                  value: checked
                }
              }, targetDomNode);
            }
          }
        } else if ((domNode.tagName === 'BUTTON' || domNode.tagName === 'BUILTIN-COMPONENT' && domNode.behavior === 'button') && evt.type === 'click' && !isCapture) {
          // 处理 button 点击
          var _type = domNode.tagName === 'BUTTON' ? domNode.getAttribute('type') : domNode.getAttribute('form-type');

          var formAttr = domNode.getAttribute('form');
          var form = formAttr ? window.document.getElementById('formAttr') : _.findParentNode(domNode, 'FORM');
          if (!form) return;
          if (_type !== 'submit' && _type !== 'reset') return;
          var inputList = form.querySelectorAll('input[name]');
          var textareaList = form.querySelectorAll('textarea[name]');
          var switchList = form.querySelectorAll('builtin-component[behavior=switch]').filter(function (item) {
            return !!item.getAttribute('name');
          });
          var sliderList = form.querySelectorAll('builtin-component[behavior=slider]').filter(function (item) {
            return !!item.getAttribute('name');
          });
          var pickerList = form.querySelectorAll('builtin-component[behavior=picker]').filter(function (item) {
            return !!item.getAttribute('name');
          });

          if (_type === 'submit') {
            var formData = {};

            if (inputList.length) {
              inputList.forEach(function (item) {
                if (item.type === 'radio') {
                  if (item.checked) formData[item.name] = item.value;
                } else if (item.type === 'checkbox') {
                  formData[item.name] = formData[item.name] || [];
                  if (item.checked) formData[item.name].push(item.value);
                } else {
                  formData[item.name] = item.value;
                }
              });
            }

            if (textareaList.length) textareaList.forEach(function (item) {
              return formData[item.getAttribute('name')] = item.value;
            });
            if (switchList.length) switchList.forEach(function (item) {
              return formData[item.getAttribute('name')] = !!item.getAttribute('checked');
            });
            if (sliderList.length) sliderList.forEach(function (item) {
              return formData[item.getAttribute('name')] = +item.getAttribute('value') || 0;
            });
            if (pickerList.length) pickerList.forEach(function (item) {
              return formData[item.getAttribute('name')] = item.getAttribute('value');
            });

            _this.callSimpleEvent('submit', {
              detail: {
                value: formData
              },
              extra: {
                $$from: 'button'
              }
            }, form);
          } else if (_type === 'reset') {
            if (inputList.length) {
              inputList.forEach(function (item) {
                if (item.type === 'radio') {
                  item.checked = false;
                } else if (item.type === 'checkbox') {
                  item.checked = false;
                } else {
                  item.value = '';
                }
              });
            }

            if (textareaList.length) textareaList.forEach(function (item) {
              return item.value = '';
            });
            if (switchList.length) switchList.forEach(function (item) {
              return item.setAttribute('checked', undefined);
            });
            if (sliderList.length) sliderList.forEach(function (item) {
              return item.setAttribute('value', undefined);
            });
            if (pickerList.length) pickerList.forEach(function (item) {
              return item.setAttribute('value', undefined);
            });

            _this.callSimpleEvent('reset', {
              extra: {
                $$from: 'button'
              }
            }, form);
          }
        }
      }, 0);
    });
  },

  /**
       * 监听节点事件
       */
  onTouchStart: function onTouchStart(evt) {
    if (this.document && this.document.$$checkEvent(evt)) {
      this.callEvent('touchstart', evt);
    }
  },
  onTouchMove: function onTouchMove(evt) {
    if (this.document && this.document.$$checkEvent(evt)) {
      this.callEvent('touchmove', evt);
    }
  },
  onTouchEnd: function onTouchEnd(evt) {
    if (this.document && this.document.$$checkEvent(evt)) {
      this.callEvent('touchend', evt);
    }
  },
  onTouchCancel: function onTouchCancel(evt) {
    if (this.document && this.document.$$checkEvent(evt)) {
      this.callEvent('touchcancel', evt);
    }
  },
  onTap: function onTap(evt) {
    if (this.document && this.document.$$checkEvent(evt)) {
      this.callEvent('click', evt, {
        button: 0
      }); // 默认左键
    }
  },
  onImgLoad: function onImgLoad(evt) {
    var pageId = this.pageId;
    var originNodeId = evt.currentTarget.dataset.privateNodeId || this.nodeId;
    var originNode = cache$1.getNode(pageId, originNodeId);
    if (!originNode) return;
    this.callSimpleEvent('load', evt, originNode);
  },
  onImgError: function onImgError(evt) {
    var pageId = this.pageId;
    var originNodeId = evt.currentTarget.dataset.privateNodeId || this.nodeId;
    var originNode = cache$1.getNode(pageId, originNodeId);
    if (!originNode) return;
    this.callSimpleEvent('error', evt, originNode);
  },
  init: initHandle.init,
  callSimpleEvent: initHandle.callSimpleEvent
}, handles$1), _Component));
