'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/picker-view.html
 */
var pickerView = {
  PROPS: [{
    name: 'value',
    get: function get(domNode) {
      var value = domNode.getAttribute('value');
      return value !== undefined ? value : [];
    }
  }, {
    name: 'indicatorStyle',
    get: function get(domNode) {
      return domNode.getAttribute('indicator-style') || '';
    }
  }, {
    name: 'indicatorClass',
    get: function get(domNode) {
      return domNode.getAttribute('indicator-class') || '';
    }
  }, {
    name: 'maskStyle',
    get: function get(domNode) {
      return domNode.getAttribute('mask-style') || '';
    }
  }, {
    name: 'maskClass',
    get: function get(domNode) {
      return domNode.getAttribute('mask-class') || '';
    }
  }],
  handles: {
    onPickerViewChange: function onPickerViewChange(evt) {
      if (!this.domNode) return;
      this.domNode.$$setAttributeWithoutUpdate('value', evt.detail.value);
      this.callSimpleEvent('change', evt);
    },
    onPickerViewPickstart: function onPickerViewPickstart(evt) {
      this.callSimpleEvent('pickstart', evt);
    },
    onPickerViewPickend: function onPickerViewPickend(evt) {
      this.callSimpleEvent('pickend', evt);
    }
  }
};

exports.default = pickerView;
