'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/progress.html
 */
var progress = {
  PROPS: [{
    name: 'percent',
    get: function get(domNode) {
      return +domNode.getAttribute('percent') || 0;
    }
  }, {
    name: 'showInfo',
    get: function get(domNode) {
      return !!domNode.getAttribute('show-info');
    }
  }, {
    name: 'borderRadius',
    get: function get(domNode) {
      return domNode.getAttribute('border-radius') || '0';
    }
  }, {
    name: 'fontSize',
    get: function get(domNode) {
      return domNode.getAttribute('font-size') || '16';
    }
  }, {
    name: 'strokeWidth',
    get: function get(domNode) {
      return domNode.getAttribute('stroke-width') || '6';
    }
  }, {
    name: 'color',
    get: function get(domNode) {
      return domNode.getAttribute('color') || '#09BB07';
    }
  }, {
    name: 'activeColor',
    get: function get(domNode) {
      return domNode.getAttribute('active-color') || '#09BB07';
    }
  }, {
    name: 'backgroundColor',
    get: function get(domNode) {
      return domNode.getAttribute('background-color') || '#EBEBEB';
    }
  }, {
    name: 'active',
    get: function get(domNode) {
      return !!domNode.getAttribute('active');
    }
  }, {
    name: 'activeMode',
    get: function get(domNode) {
      return domNode.getAttribute('active-mode') || 'backwards';
    }
  }],
  handles: {
    onProgressActiveEnd: function onProgressActiveEnd(evt) {
      this.callSimpleEvent('activeend', evt);
    }
  }
};

exports.default = progress;
