'use strict';

/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/scroll-view.html
 */
var scrollView = {
  PROPS: [{
    name: 'scrollX',
    get: function get(domNode) {
      return !!domNode.getAttribute('scroll-x');
    }
  }, {
    name: 'scrollY',
    get: function get(domNode) {
      return !!domNode.getAttribute('scroll-y');
    }
  }, {
    name: 'upperThreshold',
    get: function get(domNode) {
      var value = parseInt(domNode.getAttribute('upper-threshold'), 10);
      return !isNaN(value) ? value : 50;
    }
  }, {
    name: 'lowerThreshold',
    get: function get(domNode) {
      var value = parseInt(domNode.getAttribute('lower-threshold'), 10);
      return !isNaN(value) ? value : 50;
    }
  }, {
    name: 'scrollTop',
    get: function get(domNode) {
      var value = parseInt(domNode.getAttribute('scroll-top'), 10);
      return !isNaN(value) ? value : '';
    }
  }, {
    name: 'scrollLeft',
    get: function get(domNode) {
      var value = parseInt(domNode.getAttribute('scroll-left'), 10);
      return !isNaN(value) ? value : '';
    }
  }, {
    name: 'scrollIntoView',
    get: function get(domNode) {
      return domNode.getAttribute('scroll-into-view') || '';
    }
  }, {
    name: 'scrollWithAnimation',
    get: function get(domNode) {
      return !!domNode.getAttribute('scroll-with-animation');
    }
  }, {
    name: 'enableBackToTop',
    get: function get(domNode) {
      return !!domNode.getAttribute('enable-back-to-top');
    }
  }, {
    name: 'enableFlex',
    get: function get(domNode) {
      return !!domNode.getAttribute('enable-flex');
    }
  }],
  handles: {
    onScrollViewScrolltoupper: function onScrollViewScrolltoupper(evt) {
      this.callSimpleEvent('scrolltoupper', evt);
    },
    onScrollViewScrolltolower: function onScrollViewScrolltolower(evt) {
      this.callSimpleEvent('scrolltolower', evt);
    },
    onScrollViewScroll: function onScrollViewScroll(evt) {
      this.callSimpleEvent('scroll', evt);
    }
  }
};

exports.default = scrollView;
