'use strict';

var mp = require('miniapp-render');

var _mp$$$adapter = mp.$$adapter,
    cache = _mp$$$adapter.cache,
    tool = _mp$$$adapter.tool;
/**
 * https://developers.weixin.qq.com/miniprogram/dev/component/web-view.html
 */

var webView = {
  PROPS: [{
    name: 'src',
    get: function get(domNode) {
      var window = cache.getWindow(domNode.$$pageId);
      return domNode.src ? tool.completeURL(domNode.src, window.location.origin, true) : '';
    }
  }],
  handles: {
    onWebviewMessage: function onWebviewMessage(evt) {
      this.callSimpleEvent('message', evt);
    },
    onWebviewLoad: function onWebviewLoad(evt) {
      this.callSimpleEvent('load', evt);
    },
    onWebviewError: function onWebviewError(evt) {
      this.callSimpleEvent('error', evt);
    }
  }
};

exports.default = webView;
